Serial Wombat Arduino Library

Loading...
Searching...
No Matches
Public Member Functions | List of all members
SerialWombatServo_18AB Class Reference

A derived class that adds additional Servo Functionality for the Serial Wombat 18AB Chip. More...

`#include <SerialWombatServo.h>`

Inheritance diagram for SerialWombatServo_18AB:
[legend]
Collaboration diagram for SerialWombatServo_18AB:
[legend]

## Public Member Functions
| SerialWombatServo_18AB (SerialWombatChip &serialWombat)
uint8_t | pin ()
| Facilitates inheritance.
uint8_t | swPinModeNumber ()
| Facilitates inheritance.
Public Member Functions inherited from SerialWombatServo
| SerialWombatServo (SerialWombatChip &sw)
| Constructor for the SerialWombatServo Class.
void | attach (uint8_t pin, bool reverse)
| Initialize a servo on the specified pin.
void | attach (uint8_t pin, uint16_t min=544, uint16_t max=2400, bool reverse=false)
| Initialize a servo on the specified pin.
void | write (uint8_t angle)
| Writes a value to the servo.
void | write16bit (uint16_t position)
| Writes a 16 bit value to the servo.
uint8_t | read (void)
| returns the last position of the servo scaled to a number from 0 to 180.
Public Member Functions inherited from SerialWombatPin
| SerialWombatPin (SerialWombatChip &serialWombatChip)
| Instantiates a Serial Wombat Pin.
| SerialWombatPin (SerialWombatChip &serialWombatChip, uint8_t pin)
| Instantiates a Serial Wombat Pin.
uint16_t | readPublicData ()
| Read the 16 Bit public data associated with this pin.
void | pinMode (uint8_t mode, bool pullDown=false, bool openDrain=false)
| Set pin to INPUT or OUTPUT, with options for pull Ups and open Drain settings.
void | digitalWrite (uint8_t val)
| Set output pin High or Low.
int | digitalRead ()
| Reads the state of the Pin.
uint16_t | writePublicData (uint16_t value)
| Write a 16 bit value to this pin.
uint8_t | pin ()
| Returns the current SW pin number. Used primarily for virtual calls by derived classes.
uint8_t | swPinModeNumber ()
| Returns the Mode number. Used primarily by derived classes to populate packet data.
int16_t | initPacketNoResponse (uint8_t packetNumber, uint8_t param0=0x55, uint8_t param1=0x55, uint8_t param2=0x55, uint8_t param3=0x55, uint8_t param4=0x55)
int16_t | initPacketNoResponse (uint8_t packetNumber, uint16_t param0=0x55, uint8_t param1=0x55, uint8_t param2=0x55, uint8_t param3=0x55)
int16_t | initPacketNoResponse (uint8_t packetNumber, uint16_t param0, uint16_t param1, uint8_t param2=0x55)
int16_t | disable ()
| Disables the pin mode (if applicable)
int16_t | enablePullup (bool enabled)
| Enables the weak pull up on a pin. Implemented on SW18AB only.
int16_t | enablePullDown (bool enabled)
| Enables the weak pull down on a pin. Implemented on SW18AB only.
int16_t | enableOpenDrain (bool enabled)
| Enables open drain mode on a pin. Implemented on SW18AB only.
Public Member Functions inherited from SerialWombatAbstractScaledOutput
| SerialWombatAbstractScaledOutput (SerialWombatChip &sw)
| Constructor for the SerialWombatAbstractScaledOutput Class.
int16_t | writeTimeout (uint16_t timeout_mS, uint16_t timeoutOutputValue)
| Enable a timeout value which will cause the output to go to a default value if not updated.
int16_t | writeScalingEnabled (bool enabled, uint8_t sourcePin)
| Enable scaling and set which pin or public data is used as the input source.
int16_t | writeInputScaling (uint16_t inputMin, uint16_t inputMax)
| Scale incoming values to a range of 0 to 65535.
int16_t | writeOutputScaling (uint16_t outputMin, uint16_t outputMax)
| Reduces the output range from 0 to 65535 to user specified range.
int16_t | writeScalingInvertedInput (bool inverted)
| if enabled subtract the input value from 65535 before doing any other processing.
int16_t | writeScalingTargetValue (uint16_t target)
| The target input value for PID control.
int16_t | writeRateControl (Period samplePeriod, uint16_t maximumChangecounts)
int16_t | write1stOrderFiltering (Period sampleRate, uint16_t filterConstant)
int16_t | writeHysteresis (uint16_t lowLimit, uint16_t lowOutputValue, uint16_t highLimit, uint16_t highOutputValue, uint16_t initialOutputValue)
| Controls the output based on hystersis control.
int16_t | writeRamp (uint16_t slowIncrement, uint16_t incrementThreshold, uint16_t fastIncrement, Period samplePeriod, RampMode rampMode)
| Configure the scaled output block into Ramp control mode.
int16_t | writePID (uint16_t kp, uint16_t ki, uint16_t kd, uint16_t target, Period samplePeriod, uint8_t targetPin=255, bool biDirectional=false)
| Configure the scaled output block into PID control mode.
uint16_t | readLastOutputValue ()
| Request Last Output Value.
int16_t | writeScalingTargetValueResetIntegrator (uint16_t target)
int32_t | PIDGetLastError ()
int32_t | PIDGetLastIntegrator ()
int32_t | PIDGetLastIntegratorEffort ()
int32_t | PIDGetLastProportionalEffort ()
int32_t | PIDGetLastDerivativeEffort ()
int32_t | PIDGetLastEffort ()
uint16_t | ReadLastTarget ()
int16_t | Enable2DLookupOutputScaling (uint16_t IndexInUserMemory)
| Set Up 2D Lookup Output Scaling.

## Additional Inherited Members
Public Types inherited from SerialWombatAbstractScaledOutput
enum | Period { PERIOD_1mS = 0 , PERIOD_2mS = 1 , PERIOD_4mS = 2 , PERIOD_8mS = 3 , PERIOD_16mS = 4 , PERIOD_32mS = 5 , PERIOD_64mS = 6 , PERIOD_128mS = 7 , PERIOD_256mS = 8 , PERIOD_512mS = 9 , PERIOD_1024mS = 10 }
enum | RampMode { RAMP_MODE_BOTH = 0 , RAMP_MODE_INCREMENT = 1 , RAMP_MODE_DECREMENT = 2 }
Protected Member Functions inherited from SerialWombatServo
void | initializeServo ()
Protected Attributes inherited from SerialWombatServo
uint16_t | _position = 0
uint16_t | _min = 544
uint16_t | _max = 2400
bool | _reverse = false
Protected Attributes inherited from SerialWombatPin
uint8_t | _pin = 255
SerialWombatChip & | _sw
uint8_t | _pinMode = 0

## Detailed Description

A derived class that adds additional Servo Functionality for the Serial Wombat 18AB Chip.

The SerialWombatServo_18AB class is used to control hobby servos attached to the Serial Wombat chip.

This class extends SerialWombatServo by adding support for SerialWombatAbstractScaledOutput interfaces

Any output-capable pin may be attached to an instance of the SerialWombatServo_18AB class. A separate instance should be declared for each Servo.

On the Serial Wombat 18AB chip all Enhanced Digital Capability output pins (0-4,7,9-19) can be timed to sub-microsecond precision by sharing hardware timing resources (assuming resources are avaialble and have not be permanently claimed by PWM pin modes or other pin modes that claim and hold timing resources).

For SW18AB pins that are not enhanced, or if timing resources are not available the pin mode will degrade to using DMA based output with 17uS resolution. This equates to slightly better than 7 bit resolution for a 500-2500uS pulse range servo.

This class uses "attach" rather than "begin" to initialize servos to be consistent with the Arduino Servo native API.

Definition at line 208 of file SerialWombatServo.h.

## Constructor & Destructor Documentation

## ◆ SerialWombatServo_18AB()

SerialWombatServo_18AB::SerialWombatServo_18AB | ( | SerialWombatChip & | serialWombat | ) |
| inline

Definition at line 211 of file SerialWombatServo.h.

## Member Function Documentation

## ◆ pin()

uint8_t SerialWombatServo_18AB::pin | ( |  | ) |
| inline virtual

Facilitates inheritance.

Implements SerialWombatAbstractScaledOutput.

Definition at line 214 of file SerialWombatServo.h.

## ◆ swPinModeNumber()

uint8_t SerialWombatServo_18AB::swPinModeNumber | ( |  | ) |
| inline virtual

Facilitates inheritance.

Implements SerialWombatAbstractScaledOutput.

Definition at line 215 of file SerialWombatServo.h.